gstreamermm: Gst::TypeFindFactory Class Reference

gstreamermm 1.10.0

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gst::TypeFindFactory Class Reference

A class used to get information about registered typefind functions. More...

`#include <gstreamermm/typefindfactory.h>`

Inheritance diagram for Gst::TypeFindFactory:
[legend]

## Public Member Functions
| TypeFindFactory (TypeFindFactory&& src) noexcept
TypeFindFactory& | operator= (TypeFindFactory&& src) noexcept
| ~TypeFindFactory () noexcept override
GstTypeFindFactory* | gobj ()
| Provides access to the underlying C GObject. More...
const GstTypeFindFactory* | gobj () const
| Provides access to the underlying C GObject. More...
GstTypeFindFactory* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
std::vector< Glib::ustring > | get_extensions () const
| Gets the extensions associated with a Gst::TypeFindFactory. More...
Glib::RefPtr< Gst::Caps > | get_caps ()
| Gets the Gst::Caps associated with a typefind factory. More...
Glib::RefPtr< const Gst::Caps > | get_caps () const
| Gets the Gst::Caps associated with a typefind factory. More...
void | call_slot (Gst::TypeFind&find)
| Calls the Gst::TypeFind::SlotFind associated with this factory. More...
bool | has_function () const
| Check whether the factory has a typefind function. More...
Public Member Functions inherited from Gst::PluginFeature
| PluginFeature (PluginFeature&& src) noexcept
PluginFeature& | operator= (PluginFeature&& src) noexcept
| ~PluginFeature () noexcept override
GstPluginFeature* | gobj ()
| Provides access to the underlying C GObject. More...
const GstPluginFeature* | gobj () const
| Provides access to the underlying C GObject. More...
GstPluginFeature* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_rank (guint rank)
| Specifies a rank for a plugin feature, so that autoplugging uses the most appropriate feature. More...
guint | get_rank () const
| Gets the rank of a plugin feature. More...
Glib::RefPtr< Gst::PluginFeature > | load ()
| Loads the plugin containing feature if it's not already loaded. More...
Glib::RefPtr< Gst::Plugin > | get_plugin () const
| Get the plugin that provides this feature. More...
Glib::ustring | get_plugin_name () const
| Get the name of the plugin that provides this feature. More...
bool | check_version (guint min_major, guint min_minor, guint min_micro) const
| Checks whether the given plugin feature is at least the required version. More...
Public Member Functions inherited from Gst::Object
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
| ~Object () noexcept override
GstObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GstObject* | gobj () const
| Provides access to the underlying C GObject. More...
GstObject* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | is_element () const
bool | is_element_factory () const
bool | is_pad () const
bool | is_pad_template () const
bool | is_bin () const
guint32 | get_flags () const
| Returns the entire set of flags for the object. More...
bool | set_name (const Glib::ustring& name)
| Sets the name of object, or gives object a guaranteed unique name (if name is `nullptr`). More...
Glib::ustring | get_name () const
| Returns a copy of the name of object. More...
bool | set_parent (const Glib::RefPtr< Gst::Object >& parent)
| Sets the parent of object to parent. More...
Glib::RefPtr< Gst::Object > | get_parent ()
| Returns the parent of object. More...
Glib::RefPtr< const Gst::Object > | get_parent () const
| Returns the parent of object. More...
void | unparent ()
| Clear the parent of object, removing the associated reference. More...
void | set_control_rate (Gst::ClockTime control_rate)
| Change the control-rate for this object. More...
Gst::ClockTime | get_control_rate () const
| Obtain the control-rate for this object. More...
Gst::ClockTime | suggest_next_sync () const
| Returns a suggestion for timestamps where buffers should be split to get best controller results. More...
bool | sync_values (Gst::ClockTime timestamp)
| Sets the properties of the object, according to the Gst::ControlSources that (maybe) handle them and for the given timestamp. More...
void | set_control_bindings_disabled (bool disabled)
| This function is used to disable all controlled properties of the object for some time, i.e. sync_values() will do nothing. More...
bool | has_asctive_control_bindings () const
| Check if the object has an active controlled properties. More...
bool | has_ancestor (const Glib::RefPtr< const Gst::Object >& ancestor) const
| Check if object has an ancestor ancestor somewhere up in the hierarchy. More...
bool | has_as_ancestor (const Glib::RefPtr< Gst::Object >& ancestor) const
| Check if object has an ancestor ancestor somewhere up in the hierarchy. More...
bool | has_as_parent (const Glib::RefPtr< Gst::Object >& parent) const
| Check if parent is the parent of object. More...
Glib::ustring | get_path_string ()
| Generates a string describing the path of object in the object hierarchy. More...
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the object. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the object. More...
Glib::PropertyProxy< Glib::RefPtr< Gst::Object > > | property_parent ()
| The parent of the object. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gst::Object > > | property_parent () const
| The parent of the object. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gst::Object >&, GParamSpec* > | signal_deep_notify ()
int | get_refcount () const
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::ListHandle< Glib::RefPtr< Gst::TypeFindFactory > > | get_list ()
| Gets the list of all registered typefind factories. More...
Static Public Member Functions inherited from Gst::PluginFeature
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gst::Object
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | check_uniqueness (const Glib::ListHandle< const Gst::Object >& list, const Glib::ustring& name)
| Checks to see if there is any object named name in list. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gst::TypeFindFactory > | wrap (GstTypeFindFactory* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::PluginFeature
Glib::RefPtr< Gst::PluginFeature > | wrap (GstPluginFeature* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Object
Glib::RefPtr< Gst::Object > | wrap (GstObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gst::PluginFeature
typedef sigc::slot< bool, const Glib::RefPtr< Gst::PluginFeature >& > | SlotFilter
| For example, bool on_filter(const Glib::RefPtr<Gst::PluginFeature>& feature);. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Gst::Object
virtual void | on_deep_notify (const Glib::RefPtr< Gst::Object >& prop_object, GParamSpec* prop)
| This is a default handler for the signal signal_deep_notify(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Detailed Description

A class used to get information about registered typefind functions.

The methods in this class allow querying information about registered typefind functions.

Writing typefinders in C++ is not possible presently.

Last reviewed on 2016-08-27 (1.8.0).

## Constructor & Destructor Documentation

## ◆ TypeFindFactory()

Gst::TypeFindFactory::TypeFindFactory | ( | TypeFindFactory&& | src | ) |
| noexcept

## ◆ ~TypeFindFactory()

Gst::TypeFindFactory::~TypeFindFactory | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ call_slot()

void Gst::TypeFindFactory::call_slot | ( | Gst::TypeFind& | find | ) |

Calls the Gst::TypeFind::SlotFind associated with this factory.

Parameters

  find | A properly setup Gst::TypeFind entry. The get_data and suggest_type members must be set.

## ◆ get_caps() [1/2]

Glib::RefPtr<Gst::Caps> Gst::TypeFindFactory::get_caps | ( |  | ) |

Gets the Gst::Caps associated with a typefind factory.

Returns
  The Gst::Caps associated with this factory.

## ◆ get_caps() [2/2]

Glib::RefPtr<const Gst::Caps> Gst::TypeFindFactory::get_caps | ( |  | ) | const

Gets the Gst::Caps associated with a typefind factory.

Returns
  The Gst::Caps associated with this factory.

## ◆ get_extensions()

std::vector<Glib::ustring> Gst::TypeFindFactory::get_extensions | ( |  | ) | const

Gets the extensions associated with a Gst::TypeFindFactory.

The returned array should not be changed. If you need to change stuff in it, you should copy it using Glib::strdupv(). This function may return `nullptr` to indicate a 0-length list.

Returns
  A `nullptr`-terminated array of extensions associated with this factory.

## ◆ get_list()

static Glib::ListHandle< Glib::RefPtr<Gst::TypeFindFactory> > Gst::TypeFindFactory::get_list | ( |  | ) |
| static

Gets the list of all registered typefind factories.

You must free the list using Gst::PluginFeature::list_free().

The returned factories are sorted by highest rank first, and then by factory name.

Free-function: gst_plugin_feature_list_free

Returns
  The list of all registered Gst::TypeFindFactory.

## ◆ get_type()

static GType Gst::TypeFindFactory::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GstTypeFindFactory* Gst::TypeFindFactory::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GstTypeFindFactory* Gst::TypeFindFactory::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GstTypeFindFactory* Gst::TypeFindFactory::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ has_function()

bool Gst::TypeFindFactory::has_function | ( |  | ) | const

Check whether the factory has a typefind function.

Typefind factories without typefind functions are a last-effort fallback mechanism to e.g. assume a certain media type based on the file extension.

Returns
  `true` if the factory has a typefind functions set, otherwise `false`.

## ◆ operator=()

TypeFindFactory& Gst::TypeFindFactory::operator= | ( | TypeFindFactory&& | src | ) |
| noexcept

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gst::TypeFindFactory > wrap | ( | GstTypeFindFactory * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.